/* Win32Linux.h - Win32 API for Linux */

/* Copyright 2009, acontis technologies GmbH */

/***************************************************************************
 * DESCRIPTION
 * This module contains a subset of the Win32 API for Linux.
 *
 ***************************************************************************

0.00,12sep09,szf    written.
*/

#ifndef INCLUDE_WIN32LINUX_H
#define INCLUDE_WIN32LINUX_H

/*******************************************************************************
*                                 INCLUDES
*/
#include <rteOs.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <dlfcn.h>
#include <pthread.h>
#include <semaphore.h>
#include <errno.h>
#ifdef __cplusplus
#include <iostream>
#include <fstream>
#include <iomanip>
using namespace std;
#endif



/*******************************************************************************
*                                 DEFINES
*/
#define WAIT_OBJECT_0 0
#define WAIT_TIMEOUT 1
#define WAIT_ABANDONED 2
#define INFINITE 0xFFFFFFFF

//#define GENERIC_READ            0x01
//#define GENERIC_WRITE           0x02
//#define FILE_SHARE_READ         1
#define CREATE_ALWAYS           2
#define OPEN_EXISTING           3
//#define FILE_ATTRIBUTE_NORMAL   0x10
#define FILE_BEGIN              1
#define FILE_CURRENT            2
#define FILE_END                3
#define INVALID_FILE_SIZE       0xFFFFFFFF
#define INVALID_SET_FILE_POINTER 0xFFFFFFFF
#define WINAPI


/*******************************************************************************
*                                 MACROS
*/
#define TEXT(x) (x)
#define _tcslwr(x) (x)
#define _stricmp strcmp
#define _tcsicmp strcmp
#define _tcsnicmp strncmp
#define _tcstol strtol
#define _snwprintf snprintf
#define _getch getchar
#define FreeLibrary dlclose
#define CreateFileW CreateFile


/*******************************************************************************
*                                 TYPEDEFS
*/

//typedef unsigned long DWORD;
//typedef unsigned short WORD;
typedef DWORD* PDWORD;
//typedef DWORD* LPDWORD;
//typedef long LONG;
typedef LONG* PLONG;
typedef char* PCHAR;
typedef char* LPCTSTR;
typedef char* LPTSTR;
//typedef int INT;
typedef void* HINSTANCE;
typedef void* LPSECURITY_ATTRIBUTES;



/*******************************************************************************
*                           FORWARD DECLARATIONS
*/
void* GetProcAddress( HINSTANCE hInstRtosLib, const char* szSymbol );
void DeleteCriticalSection( CRITICAL_SECTION* pCritSec );
void InitializeCriticalSection( CRITICAL_SECTION* pCritSec );
void LeaveCriticalSection( CRITICAL_SECTION* pCritSec );
void EnterCriticalSection( CRITICAL_SECTION* pCritSec );
sem_t* CreateEvent( void* pDummy1, unsigned char bDummy2, unsigned char bDummy3, void* pDummy4 );
void DeleteEvent( sem_t* pSem );
void SetEvent( sem_t* pSem );
void ResetEvent( sem_t* pSem );
unsigned int WaitForEvent( sem_t* pSem, unsigned int dwTimeout );
void* CreateThread
(void* pvThreadAttributes
      ,unsigned int dwStackSize
      ,void* pfThreadEntry
      ,void* pvParams
      ,unsigned int dwFlags
      ,unsigned int* pdwThreadId );
void Sleep(unsigned int dwMsec);
HANDLE CreateFile
(LPCTSTR lpFileName
,DWORD dwAccess
,DWORD dwShareMode
,LPSECURITY_ATTRIBUTES lpSec
,DWORD dwDisposition
,DWORD dwFlagsAndAttrib
,HANDLE hTemplate );
BOOL WriteFile( HANDLE hMergedFile, LPVOID lpBuffer, DWORD dwNumBytes, DWORD* pdwBytesWritten, LPVOID pOverlapped );
BOOL WINAPI ReadFile(HANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,PDWORD lpNumberOfBytesRead,LPVOID lpOverlapped);
DWORD WINAPI SetFilePointer(HANDLE hFile, LONG lDistanceToMove, PLONG lpDistanceToMoveHigh, DWORD dwMoveMethod );
void CloseFile( HANDLE hFile );
void DeleteFile( LPCTSTR szFilename );
DWORD WINAPI GetFileSize(HANDLE hFile,PDWORD lpFileSizeHigh);

DWORD WINAPI GetFullPathNameA(LPCTSTR lpFileName,DWORD nBufferLength,LPTSTR lpBuffer,LPTSTR *lpFilePart);
DWORD WINAPI GetFullPathNameW(const WCHAR* lpFileName,DWORD nBufferLength,LPTSTR lpBuffer,LPTSTR *lpFilePart);


/*******************************************************************************
*                            GLOBAL FUNCTIONS
*/


#endif /* ifndef INCLUDE_WIN32LINUX_H */

/* end of file */
